/*
    Panel Free
    GNOME Shell 46+ extension
    Copyright @fthx 2024
    License GPL v3
*/


import * as Main from 'resource:///org/gnome/shell/ui/main.js';


export default class PanelFreeExtension {
    _setPanel(height, opacity) {
        Main.panel.height = height;
        Main.panel._leftBox.opacity = opacity;
        Main.panel._centerBox.opacity = opacity;
        Main.panel._rightBox.opacity = opacity;
    }

    _showPanel() {
        this._setPanel(this._panelHeight, 255);
    }

    _hidePanel() {
        this._setPanel(1, 0);
    }

    enable() {
        Main.panel.style = 'transition-duration: 0ms;';
        this._panelHeight = Main.panel.height;
        this._hidePanel();

        Main.overview.connectObject(
            'showing', this._showPanel.bind(this),
            'hiding', this._hidePanel.bind(this),
            this);
    }

    disable() {
        Main.overview.disconnectObject(this);

        Main.panel.style = null;
        this._showPanel();
        this._panelHeight = null;
    }
}
